#include "Status.h"
#include "Vram.h"
#include "Main.h"
#include "Sprite.h"
#include "Print.h"
#include "Chars.h"

constexpr byte Char_Remain = Char_Man;

static ptr<byte> PrintS(ptr<byte> pVram, ptr<byte> p)
{
    byte c;
    while ((c = *p) != 0) {
        pVram = PrintC(pVram, c);
        ++p;
    }
    return pVram;
}


void PrintStatus() 
{
    PrintS(Vram + 0, "SC");
    PrintS(Vram + 9, "HI");
    PrintS(Vram + 18, "ST");
    PrintByteNumber2(Vram + 20, CurrentStage + 1);
    PrintS(Vram+ 23, "T");
    {
        ptr<byte> pVram;
        pVram = Vram + 29 * VramStep;
        if (RemainCount > 1) {
            byte c, i;
            c = Char_Remain;

            repeat (2) {
                pVram = Put3(pVram, c);
                ++c;
            }
            pVram += VramRowSize3 - 2 * VramStep;

            repeat (2) {
                pVram = Put2(pVram, c);
                ++c;
            }
            pVram += VramRowSize2 - 2 * VramStep;

            if (RemainCount > 2) {
                pVram = PrintC(Vram + 31, RemainCount + '0' - 1);
            }
        }
    }
    PrintScore();
    PrintTime();
}

void PrintScore()
{
    ptr<byte> pVram;
    
    pVram = PrintNumber5(Vram + 2 * VramStep , Score);
    PrintC(pVram, '0');

    pVram = PrintNumber5(Vram + 11 * VramStep, HiScore);
    PrintC(pVram, '0');
}

void PrintTime()
{
    PrintByteNumber3(Vram + 24, StageTime);
}

void PrintGameOver()
{
    PrintS(Vram + VramRowSize6 * 5 + 11, "GAME OVER");
}

void PrintTimeUp() 
{
    PrintS(Vram + VramRowSize6 * 5 + 12, "TIME UP");
}

void Title()
{
    static const byte[] TitleBytes = {
        //	C
        0x00, 0x0e, 0x05, 0x0b, 
        0x0c, 0x03, 0x00, 0x00, 
        0x04, 0x0b, 0x00, 0x0a, 
        0x00, 0x04, 0x05, 0x01, 
        //	A
        0x00, 0x0e, 0x0d, 0x02, 
        0x0c, 0x03, 0x00, 0x0f, 
        0x0c, 0x07, 0x05, 0x0f, 
        0x04, 0x01, 0x00, 0x05, 
        //	V
        0x0c, 0x03, 0x00, 0x0f, 
        0x04, 0x0b, 0x08, 0x07, 
        0x00, 0x0d, 0x0e, 0x01, 
        0x00, 0x04, 0x05, 0x00, 
        //	I
        0x04, 0x0d, 0x07, 0x01, 
        0x00, 0x0c, 0x03, 0x00, 
        0x00, 0x0c, 0x03, 0x00, 
        0x04, 0x05, 0x05, 0x01, 
        //	T
        0x04, 0x0d, 0x07, 0x01, 
        0x00, 0x0c, 0x03, 0x00, 
        0x00, 0x0c, 0x03, 0x00, 
        0x00, 0x04, 0x01, 0x00, 
    };

    ClearScreen(); 
    HideAllSprites();
    PrintStatus();
    {
        ptr<byte> p;
        ptr<byte> pVram;
        pVram = Vram + VramRowSize6 * 2 + (32 - 4 * 5) / 2;
        p = TitleBytes;
        repeat (5) {
            repeat (2) {
                repeat (4) {
                    pVram = Put3(pVram, *p);
                    ++p;
                }
                pVram += VramRowSize3 - 4;
                repeat (4) {
                    pVram = Put2(pVram, *p);
                    ++p;
                }
                pVram += VramRowSize2 - 4;
            }
            pVram += 4 - VramRowSize5 * 2;
        }
    }
    PrintS(Vram + VramWidth * 46 + 7, "PUSH A OR B BUTTON");
    // {
    //     byte c;
    //     word v;
    //     v = pVram+32*10;
    //     c = 0;
    //     repeat (0) {
    //         v = Put(v, c);
    //         ++c;
    //     }
    // }
}
