include "ZeroPage.inc"
include "Vram.inc"
include "VVram.inc"

ext VVramFront_
ext Chars_, Ascii_

VramTop equ Vram+VramWidth*6
AsciiSize equ 6

dseg
Backup: defs VVramWidth*VVramHeight


pVram equ ZW0
pPattern equ ZW1
pVVram equ ZW2
pBackup equ ZW3
pFlags equ ZW4
yCount equ ZB0
xCount equ ZB1
flags equ ZB2
maskBit equ ZB3


dseg
PrintC_@Param0: public PrintC_@Param0
PrintC_pVram: 
Put3_@Param0: public Put3_@Param0
Put3_pVram: 
Put2_@Param0: public Put2_@Param0
Put2_pVram: 
    defw 0
PrintC_@Param1: public PrintC_@Param1
PrintC_c: 
Put3_@Param1: public Put3_@Param1
Put3_c:
Put2_@Param1: public Put2_@Param1
Put2_c:
    defb 0

cseg
WaitBlank:
    do
        tim #$80,$02
    while ne | wend
rts


; void ClearScreen();
cseg
ClearScreen_: public ClearScreen_
    psha
        ldaa #$aa
        ldx #Vram
        do
            staa 0,x | inx
            cpx #Vram+VramWidth*64
        while ne | wend
        
        ldx #Backup
        do
            clr 0,x | inx
            cpx #Backup+VVramWidth*VVramHeight
        while ne | wend
    pula
rts


; ptr<byte> Put3(ptr<byte> pVram, byte c);
cseg
Put3:
    ldab #5
    mul
    addd #Chars_
    std <pPattern

    ldab #3
    do
        pshb
            ldx <pPattern
            ldaa 0,x | inx
            stx <pPattern

            ldx <pVram | staa 0,x
            ldd <pVram | addd #VramWidth | std <pVram
        pulb
        decb
    while ne | wend
rts
Put3_: public Put3_
    psha | pshb
        ldx PrintC_pVram | stx <pVram
        ldaa Put3_c 
        bsr Put3
    pulb | pula
    ldx Put3_pVram | inx
rts


; ptr<byte> Put2(ptr<byte> pVram, byte c);
cseg
Put2:
    ldab #5
    mul
    addd #Chars_+3
    std <pPattern

    ldab #2
    do
        pshb
            ldx <pPattern
            ldaa 0,x | inx
            stx <pPattern

            ldx <pVram | staa 0,x
            ldd <pVram | addd #VramWidth | std <pVram
        pulb
        decb
    while ne | wend
rts
Put2_: public Put2_
    psha | pshb
        ldx PrintC_pVram | stx <pVram
        ldaa Put2_c 
        bsr Put2
    pulb | pula
    ldx Put2_pVram | inx
rts


; ptr<byte> PrintC(ptr<byte> address, byte c);
cseg
CharTable:
    defb " 0123456789ABCEGHIMNOPRSTUV"
PrintC_: public PrintC_
    psha | pshb
        ldx PrintC_pVram | stx <pVram

        ldaa PrintC_c
        clrb
        ldx #CharTable
        do
            cmpa 0,x
            beq PrintC_break
            incb
            inx
            cpx #CharTable+27
        while ne | wend
        clrb
        PrintC_break:
        ldaa #AsciiSize
        mul
        addd #Ascii_
        std <pPattern

        ldab #AsciiSize
        do
            pshb
                ldx <pPattern
                ldaa 0,x | inx
                stx <pPattern

                ldx <pVram | staa 0,x
                ldd <pVram
                addd #VramWidth
                std <pVram
            pulb
            decb
        while ne | wend
    pulb | pula
    ldx PrintC_pVram | inx
rts


; void VVramToVram();
VVramToVram_: public VVramToVram_
    psha | pshb
        ldx #VVramFront_ | stx <pVVram
        ldx #Backup | stx <pBackup
        ldx #VramTop | stx <pVram

        ldaa #VVramHeight/2 | staa <yCount
        do
            ldaa #VVramWidth
            staa <xCount
            do
                ldx <pVVram | ldaa 0,x
                ldx <pBackup | cmpa 0,x
                if ne
                    staa 0,x
                    bsr Put3
                    ldd <pVram | addd #-VramWidth*3+1 | std <pVram
                else
                    ldx <pVram | inx | stx <pVram
                endif

                ldx <pVVram | inx | stx <pVVram
                ldx <pBackup | inx | stx <pBackup
                
                dec <xCount
            while ne | wend
            ldd <pVram | addd #VramWidth*3-VVramWidth | std <pVram

            ldaa #VVramWidth
            staa <xCount
            do
                ldx <pVVram | ldaa 0,x
                ldx <pBackup | cmpa 0,x
                if ne
                    staa 0,x
                    bsr Put2
                    ldd <pVram | addd #-VramWidth*2+1 | std <pVram
                else
                    ldx <pVram | inx | stx <pVram
                endif

                ldx <pVVram | inx | stx <pVVram
                ldx <pBackup | inx | stx <pBackup

                dec <xCount
            while ne | wend

            ldd <pVram | addd #VramWidth*2-VVramWidth | std <pVram

            dec <yCount
        while ne | wend
    pulb | pula
rts
